import Modifier, { ArgsFor, NamedArgs, PositionalArgs } from 'ember-modifier';
export type Metadata = {
    dimension: 'aspectRatio' | 'height' | 'width';
    max: number;
    min: number;
};
export type Features = {
    [featureName: string]: Metadata;
};
export type Dimensions = {
    aspectRatio: number;
    height: number;
    width: number;
};
export type QueryResults = {
    [featureName: string]: boolean;
};
interface ContainerQueryModifierSignature {
    Args: {
        Named: {
            dataAttributePrefix?: string;
            debounce?: number;
            features?: Features;
            onQuery?: ({ dimensions, queryResults, }: {
                dimensions: Dimensions;
                queryResults: QueryResults;
            }) => void;
        };
        Positional: [];
    };
    Element: Element;
}
export default class ContainerQueryModifier extends Modifier<ContainerQueryModifierSignature> {
    private readonly resizeObserver;
    dimensions: Dimensions;
    queryResults: QueryResults;
    private _dataAttributes;
    private _element?;
    private _named;
    get dataAttributePrefix(): string;
    get debounce(): number;
    get features(): Features;
    constructor(owner: unknown, args: ArgsFor<ContainerQueryModifierSignature>);
    modify(element: Element, _positional: PositionalArgs<ContainerQueryModifierSignature>, named: NamedArgs<ContainerQueryModifierSignature>): void;
    private onResize;
    private registerResizeObserver;
    private queryContainer;
    private measureDimensions;
    private evaluateQueries;
    private resetDataAttributes;
    private setDataAttributes;
}
export {};
//# sourceMappingURL=container-query.d.ts.map